data {
    int N;
    array[N] int Res;
    array[N] real X;
    real mid_x;
    real max_x;
}
parameters {
    real<lower = 0.0> v_sgm;
    real v_mu;
    real<lower = 0.0> v_C;
}
transformed parameters {
    real mu;
    real C;
    real sgm;
    array[N] vector[4] p;

    mu = mid_x + v_mu * (max_x - mid_x);
    sgm = 0.001 + v_sgm * (max_x - mid_x);
    C = v_C * (max_x - mid_x);
    for (i in 1:N){
        p[i][1] = 1 - Phi((X[i] - mu + C) / sgm);
        p[i][2] = Phi((X[i] - mu + C) / sgm) - Phi((X[i] - mu) / sgm);
        p[i][3] = Phi((X[i] - mu) / sgm) - Phi((X[i] - mu - C) / sgm);
        p[i][4] = Phi((X[i] - mu - C) / sgm);
    }
}
model {
    v_mu ~ normal(0.0, 10.0);
    v_C ~ exponential(0.1);
    v_sgm ~ exponential(0.1);    // uniform(min_sgm, max_sgm);
    for (i in 1:N)
        Res[i] ~ categorical(p[i]);
}
